/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.instancezone.InstanceZone
 *  fire.pb.instancezone.faction.FactionInstZone
 *  fire.pb.item.ItemBase
 *  fire.pb.item.Pack
 *  fire.pb.map.Npc
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.npc.CSubmit2Npc
 *  fire.pb.npc.SubmitUnit
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 */
package fire.pb.instancezone.event;

import fire.pb.instancezone.InstanceZone;
import fire.pb.instancezone.event.Event;
import fire.pb.instancezone.faction.FactionInstZone;
import fire.pb.item.ItemBase;
import fire.pb.item.Pack;
import fire.pb.map.Npc;
import fire.pb.map.SceneNpcManager;
import fire.pb.npc.CSubmit2Npc;
import fire.pb.npc.SubmitUnit;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class SubmitItemEvent
extends Event {
    private long roleId;
    private CSubmit2Npc protocol;
    private int npcid;
    private int submittype;
    private final ArrayList<SubmitUnit> things;
    private long npckey;

    public SubmitItemEvent(long roleId, CSubmit2Npc protocol) {
        Npc npc;
        this.roleId = roleId;
        this.protocol = protocol;
        this.things = new ArrayList();
        this.things.addAll(protocol.things);
        this.npckey = protocol.npckey;
        this.getParams().put("roleid", roleId);
        this.getParams().put("npckey", this.npckey);
        Team team = TeamManager.getTeamByRoleId((long)roleId);
        if (team != null && team.isTeamLeader(roleId)) {
            this.getParams().put("roleids", team.getNormalMemberIds());
        }
        if (this.npckey > 0L && (npc = SceneNpcManager.getNpcByKey((long)this.npckey)) != null) {
            this.getParams().put("npcid", npc.getNpcID());
        }
        if (protocol.submittype == 13) {
            Pack bag = new Pack(roleId, true);
            LinkedList<Integer> itemids = new LinkedList<Integer>();
            for (SubmitUnit unit : this.things) {
                ItemBase item = bag.getItem(unit.key);
                if (item == null) {
                    throw new IllegalArgumentException("RoleId = " + roleId + "Key = " + unit.key + "没有这个物品，可能是物品刚移走");
                }
                itemids.add(item.getItemId());
            }
            this.getParams().put("submititems", itemids);
        }
    }

    public SubmitItemEvent(long roleid, int npcid, int submittype, List<SubmitUnit> things) {
        this.roleId = roleid;
        this.npcid = npcid;
        this.submittype = submittype;
        this.things = new ArrayList();
        this.things.addAll(things);
        this.getParams().put("roleid", this.roleId);
        if (this.npcid > 0) {
            this.getParams().put("npcid", npcid);
        }
        if (this.submittype == 13) {
            Pack bag = new Pack(this.roleId, true);
            LinkedList<Integer> itemids = new LinkedList<Integer>();
            for (SubmitUnit unit : things) {
                ItemBase item = bag.getItem(unit.key);
                if (item == null) {
                    throw new IllegalArgumentException("RoleId = " + this.roleId + "Key = " + unit.key + "没有这个物品，可能是物品刚移走");
                }
                itemids.add(item.getItemId());
            }
            this.getParams().put("submititems", itemids);
        }
    }

    public CSubmit2Npc getCSubmitNpc() {
        return this.protocol;
    }

    public ArrayList<SubmitUnit> getThings() {
        return this.things;
    }

    public long getRoleId() {
        return this.roleId;
    }

    public void setRoleId(long roleId) {
        this.roleId = roleId;
    }

    @Override
    public int getType() {
        return 8;
    }

    @Override
    public boolean process(InstanceZone instzone) {
        if (instzone instanceof FactionInstZone) {
            if (((FactionInstZone)instzone).processSubmitItem(this)) {
                return this.processDefaultResults(instzone);
            }
            return false;
        }
        return false;
    }
}

